var nsMain = Host.CreateObject("newObjects.net.NSMain");

Host.SetInput("www.newobjects.com 80 /");
Host.RequestInput("Fetch");

function OnInput(t) {
    var arr, socket, addr, addr1, strm, b, req;
    
    if (t == "") {
        Host.WriteLine("Empty address - exitting");
        return;
    }
    
    arr = t.split(" ");
    
    if (arr.length < 2) {
        Host.Msg("Wrong number of parameters!");
        Host.RequestInput("Fetch");
        return;
    }

    addr = nsMain.GetHost(arr[0]);
    Host.Clear();
    Host.WriteLine("Connecting to: [" + addr.TextAddress + "]");
    
    addr.Port = arr[1];
    
    socket = nsMain.NewSocket(); // Defaults to TCP stream socket
    
    b = socket.Socket();
    
    if (!b) {
        Host.WriteLine("Error: " + "[" + socket.LastErrorCode + "] " + socket.lastError);
        Host.RequestInput("Fetch");
        return;
    } else {
        // We request no errors
        socket.InvalidObjectsOnError = true;
        b = socket.Connect(addr);
        if (!b) {
            Host.WriteLine("Error: [" + socket.LastErrorCode + "] " + socket.lastError);
            Host.RequestInput("Fetch");
            return;
        } else {
            addr1 = socket.PeerAddress;
            if (!addr.Valid) {
                Host.WriteLine("Get peer address error: [" + addr1.LastErrorCode + "]");
            } else {
                Host.WriteLine("Peer: [" + addr1.TextAddress + "]");
            }
            addr1 = socket.SocketAddress;
            if (!addr.Valid) {
                Host.WriteLine("Get self address error: [" + addr1.LastErrorCode + "]");
            } else {
                Host.WriteLine("Socket address: [" + addr1.TextAddress + "]");
            }
            strm = Host.CreateObject("newObjects.utilctls.SFStream");
            strm.SetStream(socket);
            
            // Send the request
            req = "GET " + arr[2] + " HTTP/1.0 \r\nHost: " + arr[0] + "\r\n\r\n";
            Host.WriteLine("Sending request: " + req);
            strm.WriteText(req);
            Host.WriteLine("Waiting for response:");
            do {
                s = strm.ReadText(-2);
                Host.WriteLine(s);
            } while (s != "");
            Host.WriteLine("============= Stream ended ==============");
        }
    }
    socket.Close();
    Host.RequestInput("Fetch another");
}
    




